testSentence = ["The quick brown fox jumps over the lazy dog.", "This typing game is so fun!"]
#source for paragraphs: http://www.primaryresources.co.uk/english/pdfs/converting_sentences.pdf
firstParagraph = ["One day Phil and Leon went to the canal.", "They were going fishing.", "There seemed to be no-one else around.", "They chose the best place.", "They started to get out the rods.", "Then there was a loud splash.", "Then there was a scream. Phil and Leon looked up.", "They saw something moving in the water.", "Then they saw a hand waving.", "Someone had fallen in the water."]
secondParagraph = ["Like all animals, human beings need food in order to live.", "Every part of the body needs a steady supply of food so that it can work properly.", "First, the food has to be broken down through a process called digestion.", "It can dissolve in the blood and travel around the body."]
#correct = 0
#wrong = 0
#totalCorrect = 0
#playAgain = True;

def counter(input):
	count = 0
	for i in range(0, len(input)):
		for j in input[i]:
			count += 1
	return count

def check(paragraphArray, everyChar, userSentence):
	newSentence = ""
	correct = 0
	wrong = 0
	sentenceLen = 0;
	for i in range(0, len(everyChar)):
		if everyChar[i] == userSentence[i]:
			newSentence = newSentence + '\033[32m' + userSentence[i]
			correct += 1
		else:
			newSentence = newSentence + '\033[31m' + userSentence[i]
			wrong += 1
	sentenceLen = len(everyChar)
	return newSentence, correct, wrong, sentenceLen
		
def type(paragraph):
	totalCorrect = 0;
	print "Objective: Type the following sentences accurately."
	for i in range(0, len(paragraph)):
		userSentence = ''
		print '\033[30m' + "Sentence: " + paragraph[i]
		userSentence = raw_input('\033[30m' + "Type the sentence exactly as it is above (including capitalization, punctuation, and spaces): ")
		while len(userSentence) != len(paragraph[i]):
			print ""
			print '\033[30m' + "[ERROR] The length of your input did not match the length of the sentence. Make sure you try to copy every character."
			print ""
			print '\033[30m' + "Sentence: " + paragraph[i]
			print ""
			userSentence = raw_input('\033[30m' + "Type the sentence exactly as it is above (including capitalization, punctuation, and spaces): ")
		newSentence, correct, wrong, sentenceLen = check(paragraph, paragraph[i], userSentence)
		totalCorrect += correct
		print ""
		print newSentence
		print '\033[30m'
		print ""
		print "# of Correct Characters for this sentence: " + str(correct) + "/" + str(sentenceLen)
		print "# of Wrong Characters for this sentence: " + str(wrong) + "/" + str(sentenceLen)
		print ""
	
	lenOfList = counter(paragraph)
	percentage = "%.0f%%" % (100 * totalCorrect/lenOfList)
	print "Final Score for this Level: " + str(totalCorrect) + "/" + str(lenOfList) + " = " + str(percentage)
	
def choosePlayAgain(input):
	if input.lower() == "y":
		playAgain = True
		startGame()
	elif input.lower() == "n":
		playAgain = False
		quit()
		
def askQ():
	print ""
	ask = raw_input("Do you want to play again? Type Y or N: ")
	choosePlayAgain(ask)
	while ask.lower() != "y" or ask.lower() != "n":
		print ""
		print "[ERROR] You didn't pick Y or N. Try again!"
		print ""
		ask = raw_input("Do you want to play again? Type Y or N: ")
		choosePlayAgain(ask)
	
def chooseLevel(input):
	if input.lower() == "e":
		print ""
		print "[LEVEL] Easy: 2 sample sentences"
		print ""
		type(testSentence)
		askQ()
	elif input.lower() == "m":
		print ""
		print "[LEVEL] Medium: 10 basic sentences"
		print ""
		type(firstParagraph)
		askQ()
	elif input.lower() == "h":
		print ""
		print "[LEVEL] Hard: 4 advanced sentences"
		print ""
		type(secondParagraph)
		askQ()
		
def startGame():
	level = raw_input("Pick a level (Type E for Easy, M for Medium, or H for Hard): ")
	chooseLevel(level)
	while level.lower() != "e" or level.lower() != "m" or level.lower() != "h":
		print ""
		print "[ERROR] You didn't pick E, M, or H. Try again!"
		print ""
		level = raw_input("Pick a level (Type E for Easy, M for Medium, or H for Hard): ")
		chooseLevel(level)		

def main():
	playAgain = True
	print "Welcome to the Typing Game!"
	while playAgain:
		startGame()
		
main()